Index: squid/src/auth/basic/auth_basic.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/auth/basic/auth_basic.c,v
retrieving revision 1.1.2.20
retrieving revision 1.1.2.21
diff -u -r1.1.2.20 -r1.1.2.21
--- squid/src/auth/basic/auth_basic.c	6 Jan 2001 13:35:08 -0000	1.1.2.20
+++ squid/src/auth/basic/auth_basic.c	7 Jan 2001 09:48:32 -0000	1.1.2.21
@@ -585,27 +571,27 @@
 /* Initialize helpers and the like for this auth scheme. Called AFTER parsing the
  * config file */
 static void
-authBasicInit(authScheme *scheme)
+authBasicInit(authScheme * scheme)
 {
     static int init = 0;
-    if (basicConfig->authenticate){
-        if (!basic_data_pool)
-            basic_data_pool = memPoolCreate("Basic Scheme User Data", sizeof(basic_data));
-        authbasic_initialised = 1;
-        if (basicauthenticators == NULL)
-                basicauthenticators = helperCreate("basicauthenticator");
-        basicauthenticators->cmdline = basicConfig->authenticate;
-        basicauthenticators->n_to_start = basicConfig->authenticateChildren;
-        basicauthenticators->ipc_type = IPC_TCP_SOCKET;
-        helperOpenServers(basicauthenticators);
-        if (!init) {
-            cachemgrRegister("basicauthenticator",
-                "User Authenticator Stats",
-                authenticateBasicStats, 0, 1);
-                init++;
-            }
-        CBDATA_INIT_TYPE(authenticateStateData);
-        } 
+    if (basicConfig->authenticate) {
+	if (!basic_data_pool)
+	    basic_data_pool = memPoolCreate("Basic Scheme User Data", sizeof(basic_data));
+	authbasic_initialised = 1;
+	if (basicauthenticators == NULL)
+	    basicauthenticators = helperCreate("basicauthenticator");
+	basicauthenticators->cmdline = basicConfig->authenticate;
+	basicauthenticators->n_to_start = basicConfig->authenticateChildren;
+	basicauthenticators->ipc_type = IPC_TCP_SOCKET;
+	helperOpenServers(basicauthenticators);
+	if (!init) {
+	    cachemgrRegister("basicauthenticator",
+		"User Authenticator Stats",
+		authenticateBasicStats, 0, 1);
+	    init++;
+	}
+	CBDATA_INIT_TYPE(authenticateStateData);
+    }
 }
 
 /* send the initial data to a basic authenticator module */
@@ -614,44 +600,41 @@
 {
     authenticateStateData *r = NULL;
     char buf[8192];
-    basic_data * basic_auth;
+    basic_data *basic_auth;
     assert(auth_user_request);
     assert(handler);
-    assert(auth_user_request->auth_user->auth_type==AUTH_BASIC);
+    assert(auth_user_request->auth_user->auth_type == AUTH_BASIC);
     assert(auth_user_request->auth_user->scheme_data != NULL);
     basic_auth = auth_user_request->auth_user->scheme_data;
     debug(29, 9) ("authenticateStart: '%s:%s'\n", basic_auth->username,
-        basic_auth->passwd);
+	basic_auth->passwd);
     if (basicConfig->authenticate == NULL) {
-        handler(data, NULL);
-        return;
+	handler(data, NULL);
+	return;
     }
     /* check to see if the auth_user already has a request outstanding */
-    if (auth_user_request->auth_user->flags.credentials_ok==2)
-    {
-        /* there is a request with the same credentials already being verified */
-        auth_basic_queue_node *node;
-        node=xmalloc(sizeof(auth_basic_queue_node));
-        assert(node);
-        /* save the details */
-        node->next=basic_auth->auth_queue;
-        basic_auth->auth_queue=node;
-        node->auth_user_request=auth_user_request;
-        node->handler=handler;
-        node->data=data;
-        cbdataLock(data);
-        return;
-    }
-    else
-    {
-        r = CBDATA_ALLOC(authenticateStateData, NULL);
-        r->handler = handler;
-        cbdataLock(data);
-        r->data = data;
-        r->auth_user_request = auth_user_request;
-        /* mark the user as haveing verification in progress */
-        auth_user_request->auth_user->flags.credentials_ok=2;
-        snprintf(buf, 8192, "%s %s\n", basic_auth->username, basic_auth->passwd);
-        helperSubmit(basicauthenticators, buf, authenticateBasicHandleReply, r);
+    if (auth_user_request->auth_user->flags.credentials_ok == 2) {
+	/* there is a request with the same credentials already being verified */
+	auth_basic_queue_node *node;
+	node = xmalloc(sizeof(auth_basic_queue_node));
+	assert(node);
+	/* save the details */
+	node->next = basic_auth->auth_queue;
+	basic_auth->auth_queue = node;
+	node->auth_user_request = auth_user_request;
+	node->handler = handler;
+	node->data = data;
+	cbdataLock(data);
+	return;
+    } else {
+	r = CBDATA_ALLOC(authenticateStateData, NULL);
+	r->handler = handler;
+	cbdataLock(data);
+	r->data = data;
+	r->auth_user_request = auth_user_request;
+	/* mark the user as haveing verification in progress */
+	auth_user_request->auth_user->flags.credentials_ok = 2;
+	snprintf(buf, 8192, "%s %s\n", basic_auth->username, basic_auth->passwd);
+	helperSubmit(basicauthenticators, buf, authenticateBasicHandleReply, r);
     }
 }
Index: squid/src/auth/ntlm/auth_ntlm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/auth/ntlm/auth_ntlm.c,v
retrieving revision 1.1.2.17
retrieving revision 1.1.2.18
diff -u -r1.1.2.17 -r1.1.2.18
--- squid/src/auth/ntlm/auth_ntlm.c	7 Jan 2001 02:49:32 -0000	1.1.2.17
+++ squid/src/auth/ntlm/auth_ntlm.c	7 Jan 2001 09:48:32 -0000	1.1.2.18
@@ -34,8 +34,8 @@
  */
 
 /* The functions in this file handle authentication.
-   They DO NOT perform access control or auditing.
-   See acl.c for access control and client_side.c for auditing */
+ * They DO NOT perform access control or auditing.
+ * See acl.c for access control and client_side.c for auditing */
 
 
 #include "squid.h"
@@ -50,27 +50,27 @@
 /* NTLM Scheme */
 static HLPSCB authenticateNTLMHandleReply;
 static HLPSCB authenticateNTLMHandleplaceholder;
-static AUTHSACTIVE    authenticateNTLMActive;
-static AUTHSAUTHED    authNTLMAuthenticated;
-static AUTHSAUTHUSER  authenticateNTLMAuthenticateUser;
-static AUTHSFIXERR    authenticateNTLMFixErrorHeader;
-static AUTHSFREE      authenticateNTLMFreeUser;
+static AUTHSACTIVE authenticateNTLMActive;
+static AUTHSAUTHED authNTLMAuthenticated;
+static AUTHSAUTHUSER authenticateNTLMAuthenticateUser;
+static AUTHSFIXERR authenticateNTLMFixErrorHeader;
+static AUTHSFREE authenticateNTLMFreeUser;
 static AUTHSDIRECTION authenticateNTLMDirection;
 static AUTHSDECODE authenticateDecodeNTLMAuth;
-static AUTHSDUMP      authNTLMCfgDump;
+static AUTHSDUMP authNTLMCfgDump;
 static AUTHSFREECONFIG authNTLMFreeConfig;
-static AUTHSINIT       authNTLMInit;
+static AUTHSINIT authNTLMInit;
 static AUTHSONCLOSEC authenticateNTLMOnCloseConnection;
 static AUTHSUSERNAME authenticateNTLMUsername;
-static AUTHSREQFREE  authNTLMAURequestFree;
-static AUTHSPARSE    authNTLMParse;
-static AUTHSSTART    authenticateNTLMStart;
-static AUTHSSTATS    authenticateNTLMStats;
+static AUTHSREQFREE authNTLMAURequestFree;
+static AUTHSPARSE authNTLMParse;
+static AUTHSSTART authenticateNTLMStart;
+static AUTHSSTATS authenticateNTLMStats;
 static AUTHSSHUTDOWN authNTLMDone;
 
 /* helper callbacks to handle per server state data */
-static HLPSAVAIL     authenticateNTLMHelperServerAvailable;
-static HLPSONEQ      authenticateNTLMHelperServerOnEmpty;
+static HLPSAVAIL authenticateNTLMHelperServerAvailable;
+static HLPSONEQ authenticateNTLMHelperServerOnEmpty;
 
 static statefulhelper *ntlmauthenticators = NULL;
 
@@ -81,7 +81,7 @@
 MemPool *ntlm_helper_state_pool = NULL;
 MemPool *ntlm_user_pool = NULL;
 MemPool *ntlm_request_pool = NULL;
-static auth_ntlm_config * ntlmConfig = NULL;
+static auth_ntlm_config *ntlmConfig = NULL;
 
 static hash_table *proxy_auth_cache = NULL;
 
@@ -97,109 +97,99 @@
 //    memPoolDestroy(ufs_state_pool);
 
     if (ntlmauthenticators)
-        helperStatefulShutdown(ntlmauthenticators);
+	helperStatefulShutdown(ntlmauthenticators);
     authntlm_initialised = 0;
     if (!shutting_down)
-        return;
+	return;
     helperStatefulFree(ntlmauthenticators);
     ntlmauthenticators = NULL;
     memPoolDestroy(ntlm_helper_state_pool);
     memPoolDestroy(ntlm_request_pool);
     memPoolDestroy(ntlm_user_pool);
-    
+
 }
 
 /* free any allocated configuration details */
 void
-authNTLMFreeConfig(authScheme *scheme)
+authNTLMFreeConfig(authScheme * scheme)
 {
-    if (ntlmConfig==NULL)
-        return;
-    assert(ntlmConfig==scheme->scheme_data);
+    if (ntlmConfig == NULL)
+	return;
+    assert(ntlmConfig == scheme->scheme_data);
     if (ntlmConfig->authenticate)
-        wordlistDestroy(&ntlmConfig->authenticate);
-   xfree(ntlmConfig);
-   ntlmConfig=NULL;
+	wordlistDestroy(&ntlmConfig->authenticate);
+    xfree(ntlmConfig);
+    ntlmConfig = NULL;
 }
 
 static void
-authNTLMCfgDump(StoreEntry *entry, const char * name, authScheme *scheme)
+authNTLMCfgDump(StoreEntry * entry, const char *name, authScheme * scheme)
 {
-   auth_ntlm_config *config=scheme->scheme_data;
-   wordlist *list=config->authenticate;
-   storeAppendPrintf(entry, "%s %s", name, "ntlm");
-   while (list !=NULL)
-   {
-        storeAppendPrintf(entry, " %s", list->key);
-        list = list->next;
-   }
-   storeAppendPrintf(entry, "\n%s %s children %d\n%s %s max_challenge_reuses %d\n%s %s max_challenge_lifetime %d seconds\n",
-        name, "ntlm", config->authenticateChildren,
-        name, "ntlm", config->challengeuses,
-        name, "ntlm", config->challengelifetime);
+    auth_ntlm_config *config = scheme->scheme_data;
+    wordlist *list = config->authenticate;
+    storeAppendPrintf(entry, "%s %s", name, "ntlm");
+    while (list != NULL) {
+	storeAppendPrintf(entry, " %s", list->key);
+	list = list->next;
+    }
+    storeAppendPrintf(entry, "\n%s %s children %d\n%s %s max_challenge_reuses %d\n%s %s max_challenge_lifetime %d seconds\n",
+	name, "ntlm", config->authenticateChildren,
+	name, "ntlm", config->challengeuses,
+	name, "ntlm", config->challengelifetime);
 
 }
 
 static void
-authNTLMParse(authScheme *scheme, int n_configured, char *param_str)
+authNTLMParse(authScheme * scheme, int n_configured, char *param_str)
 {
-    if (scheme->scheme_data==NULL)
-    {
-        assert (ntlmConfig==NULL);
-        /* this is the first param to be found */
-        scheme->scheme_data=xmalloc(sizeof(auth_ntlm_config));
-        memset(scheme->scheme_data, 0, sizeof(auth_ntlm_config));
-        ntlmConfig=scheme->scheme_data;
-        ntlmConfig->authenticateChildren=5;
-        ntlmConfig->challengeuses=0;
-        ntlmConfig->challengelifetime=60;
-    }
-    ntlmConfig=scheme->scheme_data;
-    if (strcasecmp(param_str,"program")==0)
-    {
-        parse_wordlist(&ntlmConfig->authenticate);
-        requirePathnameExists("authparam ntlm program",ntlmConfig->authenticate->key);
-    }
-    else if (strcasecmp(param_str,"children")==0)
-    {
-        parse_int(&ntlmConfig->authenticateChildren);
-    }
-    else if (strcasecmp(param_str,"max_challenge_reuses")==0)
-    {
-        parse_int(&ntlmConfig->challengeuses);
-    }
-    else if (strcasecmp(param_str,"max_challenge_lifetime")==0)
-    {
-        parse_time_t(&ntlmConfig->challengelifetime);
-    }
-    else
-    {
-        debug(28,0)("unrecognised ntlm auth scheme parameter '%s'\n",param_str);
+    if (scheme->scheme_data == NULL) {
+	assert(ntlmConfig == NULL);
+	/* this is the first param to be found */
+	scheme->scheme_data = xmalloc(sizeof(auth_ntlm_config));
+	memset(scheme->scheme_data, 0, sizeof(auth_ntlm_config));
+	ntlmConfig = scheme->scheme_data;
+	ntlmConfig->authenticateChildren = 5;
+	ntlmConfig->challengeuses = 0;
+	ntlmConfig->challengelifetime = 60;
+    }
+    ntlmConfig = scheme->scheme_data;
+    if (strcasecmp(param_str, "program") == 0) {
+	parse_wordlist(&ntlmConfig->authenticate);
+	requirePathnameExists("authparam ntlm program", ntlmConfig->authenticate->key);
+    } else if (strcasecmp(param_str, "children") == 0) {
+	parse_int(&ntlmConfig->authenticateChildren);
+    } else if (strcasecmp(param_str, "max_challenge_reuses") == 0) {
+	parse_int(&ntlmConfig->challengeuses);
+    } else if (strcasecmp(param_str, "max_challenge_lifetime") == 0) {
+	parse_time_t(&ntlmConfig->challengelifetime);
+    } else {
+	debug(28, 0) ("unrecognised ntlm auth scheme parameter '%s'\n", param_str);
     }
 }
 
 
 void
-authSchemeSetup_ntlm(authscheme_entry_t *authscheme) {
+authSchemeSetup_ntlm(authscheme_entry_t * authscheme)
+{
 #if 0
-static int ntlminit = 0;
+    static int ntlminit = 0;
 #endif
     assert(!authntlm_initialised);
-    authscheme->Active            =authenticateNTLMActive;
-    authscheme->parse             =authNTLMParse;
-    authscheme->dump              =authNTLMCfgDump;
-    authscheme->requestFree       =authNTLMAURequestFree;
-    authscheme->freeconfig        =authNTLMFreeConfig;
-    authscheme->init              =authNTLMInit;
+    authscheme->Active = authenticateNTLMActive;
+    authscheme->parse = authNTLMParse;
+    authscheme->dump = authNTLMCfgDump;
+    authscheme->requestFree = authNTLMAURequestFree;
+    authscheme->freeconfig = authNTLMFreeConfig;
+    authscheme->init = authNTLMInit;
     authscheme->authAuthenticate = authenticateNTLMAuthenticateUser;
-    authscheme->authenticated    = authNTLMAuthenticated;
-    authscheme->authFixHeader=authenticateNTLMFixErrorHeader;
-    authscheme->FreeUser          =authenticateNTLMFreeUser;
-    authscheme->authStart   =authenticateNTLMStart;
-    authscheme->authStats   =authenticateNTLMStats;
+    authscheme->authenticated = authNTLMAuthenticated;
+    authscheme->authFixHeader = authenticateNTLMFixErrorHeader;
+    authscheme->FreeUser = authenticateNTLMFreeUser;
+    authscheme->authStart = authenticateNTLMStart;
+    authscheme->authStats = authenticateNTLMStats;
     authscheme->authUserUsername = authenticateNTLMUsername;
-    authscheme->getdirection=authenticateNTLMDirection;
-    authscheme->decodeauth  =authenticateDecodeNTLMAuth;
+    authscheme->getdirection = authenticateNTLMDirection;
+    authscheme->decodeauth = authenticateDecodeNTLMAuth;
     authscheme->donefunc = authNTLMDone;
     authscheme->oncloseconnection = authenticateNTLMOnCloseConnection;
 }
@@ -207,67 +197,68 @@
 /* Initialize helpers and the like for this auth scheme. Called AFTER parsing the
  * config file */
 static void
-authNTLMInit(authScheme *scheme)
+authNTLMInit(authScheme * scheme)
 {
     static int ntlminit = 0;
-    if (ntlmConfig->authenticate)
-    {
-        if (!ntlm_helper_state_pool)
-            ntlm_helper_state_pool = memPoolCreate("NTLM Helper State data", sizeof(ntlm_helper_state_t));
-        if (!ntlm_user_pool)
-            ntlm_user_pool = memPoolCreate("NTLM Scheme User Data", sizeof(ntlm_user_t));
-        if (!ntlm_request_pool)
-            ntlm_request_pool = memPoolCreate("NTLM Scheme Request Data", sizeof(ntlm_request_t));
-        authntlm_initialised = 1;
-        if (ntlmauthenticators == NULL)
-            ntlmauthenticators = helperStatefulCreate("ntlmauthenticator");
-        if (!proxy_auth_cache)
-            proxy_auth_cache = hash_create((HASHCMP *) strcmp, 7921, hash_string);
-        assert(proxy_auth_cache);
-        ntlmauthenticators->cmdline = ntlmConfig->authenticate;
-        ntlmauthenticators->n_to_start = ntlmConfig->authenticateChildren;
-        ntlmauthenticators->ipc_type = IPC_TCP_SOCKET;
-        ntlmauthenticators->datapool=ntlm_helper_state_pool;
-        ntlmauthenticators->IsAvailable=authenticateNTLMHelperServerAvailable;
-        ntlmauthenticators->OnEmptyQueue=authenticateNTLMHelperServerOnEmpty;
-        helperStatefulOpenServers(ntlmauthenticators);
-        /* TODO: In here send the initial YR to preinitialise the challenge cache */
-        /* Think about this... currently we ask when the challenge is needed. Better?*/
-        if (!ntlminit) 
-        {
-            cachemgrRegister("ntlmauthenticator",
-                "User NTLM Authenticator Stats",
-                authenticateNTLMStats, 0, 1);
-            ntlminit++;
-        }
-        CBDATA_INIT_TYPE(authenticateStateData);
+    if (ntlmConfig->authenticate) {
+	if (!ntlm_helper_state_pool)
+	    ntlm_helper_state_pool = memPoolCreate("NTLM Helper State data", sizeof(ntlm_helper_state_t));
+	if (!ntlm_user_pool)
+	    ntlm_user_pool = memPoolCreate("NTLM Scheme User Data", sizeof(ntlm_user_t));
+	if (!ntlm_request_pool)
+	    ntlm_request_pool = memPoolCreate("NTLM Scheme Request Data", sizeof(ntlm_request_t));
+	authntlm_initialised = 1;
+	if (ntlmauthenticators == NULL)
+	    ntlmauthenticators = helperStatefulCreate("ntlmauthenticator");
+	if (!proxy_auth_cache)
+	    proxy_auth_cache = hash_create((HASHCMP *) strcmp, 7921, hash_string);
+	assert(proxy_auth_cache);
+	ntlmauthenticators->cmdline = ntlmConfig->authenticate;
+	ntlmauthenticators->n_to_start = ntlmConfig->authenticateChildren;
+	ntlmauthenticators->ipc_type = IPC_TCP_SOCKET;
+	ntlmauthenticators->datapool = ntlm_helper_state_pool;
+	ntlmauthenticators->IsAvailable = authenticateNTLMHelperServerAvailable;
+	ntlmauthenticators->OnEmptyQueue = authenticateNTLMHelperServerOnEmpty;
+	helperStatefulOpenServers(ntlmauthenticators);
+	/* TODO: In here send the initial YR to preinitialise the challenge cache */
+	/* Think about this... currently we ask when the challenge is needed. Better? */
+	if (!ntlminit) {
+	    cachemgrRegister("ntlmauthenticator",
+		"User NTLM Authenticator Stats",
+		authenticateNTLMStats, 0, 1);
+	    ntlminit++;
+	}
+	CBDATA_INIT_TYPE(authenticateStateData);
     }
 }
 
 int
-authenticateNTLMActive(){
+authenticateNTLMActive()
+{
     if (authntlm_initialised)
-        return 1;
+	return 1;
     else
-        return 0;
+	return 0;
 }
 
 /* NTLM Scheme */
 
-int authenticateNTLMDirection(auth_user_request_t *auth_user_request) {
-    ntlm_request_t * ntlm_request = auth_user_request->scheme_data;
+int
+authenticateNTLMDirection(auth_user_request_t * auth_user_request)
+{
+    ntlm_request_t *ntlm_request = auth_user_request->scheme_data;
 /* null auth_user is checked for by authenticateDirection */
     switch (ntlm_request->auth_state) {
-        case AUTHENTICATE_STATE_NONE: /* no progress at all.*/
-            debug(28,1) ("authenticateNTLMDirection: called before NTLM Authenticate!. Report a bug to squid-dev.\n");
-            return -2;
-        case AUTHENTICATE_STATE_NEGOTIATE: /* send to helper */
-        case AUTHENTICATE_STATE_RESPONSE: /*send to helper */
-            return -1;
-        case AUTHENTICATE_STATE_CHALLENGE: /* send to client */
-            return 1;
-        case AUTHENTICATE_STATE_DONE: /* do nothing.. */
-            return 0;
+    case AUTHENTICATE_STATE_NONE:	/* no progress at all. */
+	debug(28, 1) ("authenticateNTLMDirection: called before NTLM Authenticate!. Report a bug to squid-dev.\n");
+	return -2;
+    case AUTHENTICATE_STATE_NEGOTIATE:		/* send to helper */
+    case AUTHENTICATE_STATE_RESPONSE:	/*send to helper */
+	return -1;
+    case AUTHENTICATE_STATE_CHALLENGE:		/* send to client */
+	return 1;
+    case AUTHENTICATE_STATE_DONE:	/* do nothing.. */
+	return 0;
     }
     return -2;
 }
@@ -278,41 +269,42 @@
  * else.
  */
 void
-authenticateNTLMFixErrorHeader(auth_user_request_t *auth_user_request, HttpReply *rep, http_hdr_type type, request_t * request){
-    ntlm_request_t * ntlm_request;
-    if (ntlmConfig->authenticate){
-        /* New request, no user details */
-        if (auth_user_request == NULL) {
-            debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n",type);
-            httpHeaderPutStrf(&rep->header, type, "NTLM");
-            /* drop the connection */
-            httpHeaderDelByName(&rep->header, "keep-alive"); 
-            /* NTLM has problems if the initial connection is not dropped
-               I haven't checked the RFC compliance of this hack - RBCollins*/
-            request->flags.proxy_keepalive = 0;
-        } else {
-            ntlm_request=auth_user_request->scheme_data;
-            switch (ntlm_request->auth_state){
-            case AUTHENTICATE_STATE_NONE:
-                debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n",type);
-                httpHeaderPutStrf(&rep->header, type, "NTLM");
-                /* drop the connection */
-                httpHeaderDelByName(&rep->header, "keep-alive");
-                /* NTLM has problems if the initial connection is not dropped
-                 I haven't checked the RFC compliance of this hack - RBCollins*/
-                request->flags.proxy_keepalive = 0;
-            break;
-            case AUTHENTICATE_STATE_CHALLENGE: 
-                /* we are 'waiting' for a response */
-                /* pass the challenge to the client */
-                debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM %s'\n",type,ntlm_request->authchallenge);
-                httpHeaderPutStrf(&rep->header, type, "NTLM %s", ntlm_request->authchallenge);
-            break;
-            default:
-                debug(29,0)("authenticateNTLMFixErrorHeader: state %d.\n",ntlm_request->auth_state);
-                fatal("unexpected state in AuthenticateNTLMFixErrorHeader.\n");
-            }
-        }
+authenticateNTLMFixErrorHeader(auth_user_request_t * auth_user_request, HttpReply * rep, http_hdr_type type, request_t * request)
+{
+    ntlm_request_t *ntlm_request;
+    if (ntlmConfig->authenticate) {
+	/* New request, no user details */
+	if (auth_user_request == NULL) {
+	    debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
+	    httpHeaderPutStrf(&rep->header, type, "NTLM");
+	    /* drop the connection */
+	    httpHeaderDelByName(&rep->header, "keep-alive");
+	    /* NTLM has problems if the initial connection is not dropped
+	     * I haven't checked the RFC compliance of this hack - RBCollins */
+	    request->flags.proxy_keepalive = 0;
+	} else {
+	    ntlm_request = auth_user_request->scheme_data;
+	    switch (ntlm_request->auth_state) {
+	    case AUTHENTICATE_STATE_NONE:
+		debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
+		httpHeaderPutStrf(&rep->header, type, "NTLM");
+		/* drop the connection */
+		httpHeaderDelByName(&rep->header, "keep-alive");
+		/* NTLM has problems if the initial connection is not dropped
+		 * I haven't checked the RFC compliance of this hack - RBCollins */
+		request->flags.proxy_keepalive = 0;
+		break;
+	    case AUTHENTICATE_STATE_CHALLENGE:
+		/* we are 'waiting' for a response */
+		/* pass the challenge to the client */
+		debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM %s'\n", type, ntlm_request->authchallenge);
+		httpHeaderPutStrf(&rep->header, type, "NTLM %s", ntlm_request->authchallenge);
+		break;
+	    default:
+		debug(29, 0) ("authenticateNTLMFixErrorHeader: state %d.\n", ntlm_request->auth_state);
+		fatal("unexpected state in AuthenticateNTLMFixErrorHeader.\n");
+	    }
+	}
     }
 }
 
@@ -320,13 +312,13 @@
 authNTLMRequestFree(ntlm_request_t * ntlm_request)
 {
     if (!ntlm_request)
-        return;
+	return;
     if (ntlm_request->ntlmnegotiate)
-        xfree(ntlm_request->ntlmnegotiate);
+	xfree(ntlm_request->ntlmnegotiate);
     if (ntlm_request->authchallenge)
-        xfree(ntlm_request->authchallenge);
+	xfree(ntlm_request->authchallenge);
     if (ntlm_request->ntlmauthenticate)
-        xfree(ntlm_request->ntlmauthenticate);
+	xfree(ntlm_request->ntlmauthenticate);
     memPoolFree(ntlm_request_pool, ntlm_request);
 }
 
@@ -334,68 +326,68 @@
 authNTLMAURequestFree(auth_user_request_t * auth_user_request)
 {
     if (auth_user_request->scheme_data)
-        authNTLMRequestFree((ntlm_request_t *)auth_user_request->scheme_data);
-    auth_user_request->scheme_data=NULL;
+	authNTLMRequestFree((ntlm_request_t *) auth_user_request->scheme_data);
+    auth_user_request->scheme_data = NULL;
 }
 
 void
-authenticateNTLMFreeUser(auth_user_t *auth_user) {
+authenticateNTLMFreeUser(auth_user_t * auth_user)
+{
     dlink_node *link, *tmplink;
-    ntlm_user_t * ntlm_user = auth_user->scheme_data;
+    ntlm_user_t *ntlm_user = auth_user->scheme_data;
     auth_user_hash_pointer *proxy_auth_hash;
-    
-    debug(29,5) ("authenticateNTLMFreeUser: Clearing NTLM scheme data\n");
+
+    debug(29, 5) ("authenticateNTLMFreeUser: Clearing NTLM scheme data\n");
     if (ntlm_user->username)
-        xfree(ntlm_user->username);
+	xfree(ntlm_user->username);
     /* were they linked in by one or more proxy-authenticate headers */
     link = ntlm_user->proxy_auth_list.head;
     while (link) {
-        debug(29,9) ("authenticateFreeProxyAuthUser: removing proxy_auth hash entry '%d'\n
-",link->data);
-        proxy_auth_hash = link->data;
-        tmplink=link;
-        link=link->next;
-        dlinkDelete(tmplink, &ntlm_user->proxy_auth_list);
-        hash_remove_link(proxy_auth_cache, (hash_link *) proxy_auth_hash);
-        /* free the key (usually the proxy_auth header) */
-        xfree(proxy_auth_hash->key);
-        memFree(proxy_auth_hash, MEM_AUTH_USER_HASH);
+	debug(29, 9) ("authenticateFreeProxyAuthUser: removing proxy_auth hash entry '%d'\n", link->data);
+	proxy_auth_hash = link->data;
+	tmplink = link;
+	link = link->next;
+	dlinkDelete(tmplink, &ntlm_user->proxy_auth_list);
+	hash_remove_link(proxy_auth_cache, (hash_link *) proxy_auth_hash);
+	/* free the key (usually the proxy_auth header) */
+	xfree(proxy_auth_hash->key);
+	memFree(proxy_auth_hash, MEM_AUTH_USER_HASH);
     }
     memPoolFree(ntlm_user_pool, ntlm_user);
-    auth_user->scheme_data = NULL; 
+    auth_user->scheme_data = NULL;
 }
 
 static stateful_helper_callback_t
-authenticateNTLMHandleplaceholder(void *data, void * lastserver, char *reply)
+authenticateNTLMHandleplaceholder(void *data, void *lastserver, char *reply)
 {
     authenticateStateData *r = data;
     stateful_helper_callback_t result = S_HELPER_UNKNOWN;
     int valid;
     /* we should only be called for placeholder requests - which have no reply string */
-    assert (reply == NULL); 
-    assert (r->auth_user_request);
+    assert(reply == NULL);
+    assert(r->auth_user_request);
     /* standard callback stuff */
     valid = cbdataValid(r->data);
     cbdataUnlock(r->data);
     /* call authenticateNTLMStart to retry this request */
-    debug(29,9)("authenticateNTLMHandleplaceholder: calling authenticateNTLMStart\n");
-    authenticateNTLMStart(r->auth_user_request, r->handler, r->data);    
+    debug(29, 9) ("authenticateNTLMHandleplaceholder: calling authenticateNTLMStart\n");
+    authenticateNTLMStart(r->auth_user_request, r->handler, r->data);
     authenticateStateFree(r);
     return result;
 }
 
 static stateful_helper_callback_t
-authenticateNTLMHandleReply(void *data, void * lastserver, char *reply)
+authenticateNTLMHandleReply(void *data, void *lastserver, char *reply)
 {
 #if 0
     authenticateStatefulStateData *r = data;
 #endif
     authenticateStateData *r = data;
-    ntlm_helper_state_t * helperstate;
+    ntlm_helper_state_t *helperstate;
     int valid;
     stateful_helper_callback_t result = S_HELPER_UNKNOWN;
 #if 0
-    void *nextserver=NULL;
+    void *nextserver = NULL;
 #endif
     char *t = NULL;
     auth_user_request_t *auth_user_request;
